/* GCC */

#include <fstream>
#include <cmath>

const double pi = acos(-1);

void rotate(double a,double& x,double& y,double fi)
{
    x -= a/2;
    y -= a/2;
    double x1 = x*cos(fi) - y*sin(fi);
    double y1 = x*sin(fi) + y*cos(fi);
    x = x1 + a/2;
    y = y1 + a/2;
}

void symmetry(double a,double& x,double& y)
{
    x -= a/2;
    x *= -1;
    x += a/2;
}

int main()
{
    std::ifstream in("cube.in");
    double a;
    double x1,y1,z1;
    double x2,y2,z2;
    in >> a >> x1 >> y1 >> z1 >>
               x2 >> y2 >> z2;
    in.close();
    double answer = 1000*1000*1000;
    if(z2 == 0)
        answer = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2);
    else if(z2 != a)
    {
        while(y2 != a)
        {
            rotate(a,x1,y1,pi/2);
            rotate(a,x2,y2,pi/2);
        }
        double dx = x1 - x2;
        double dy = y1 - (a + z2);
        answer = std::min(answer,dx*dx + dy*dy);
        for(int i = 0;i < 2;i++)
        {
            double du = x1 - (a + z2);
            double dv = y1 - (2*a - x2);
            double k = dv/du;
            double b = y1 - k*x1;
            if(k*a + b <= a)
                answer = std::min(answer,du*du + dv*dv);
            symmetry(a,x1,y1);
            symmetry(a,x2,y2);
        }
    }
    else
    {
        for(int i = 0;i < 4;i++)
        {
            double dx = x1 - x2;
            double dy = y1 - (3*a - y2);
            answer = std::min(answer,dx*dx + dy*dy);
            for(int j = 0;j < 2;j++)
            {
                double du = x1 - (2*a - y2);
                double dv = y1 - (3*a - x2);
                double k = dv/du;
                double b = y1 - k*x1;
                if(k*a + b >= a && k*a + b <= 2*a)
                    answer = std::min(answer,du*du + dv*dv);
                symmetry(a,x1,y1);
                symmetry(a,x2,y2);
            }
            rotate(a,x1,y1,pi/2);
            rotate(a,x2,y2,pi/2);
        }
    }
    std::ofstream out("cube.out");
    out << (int)answer << std::endl;
    out.close();
}
